#include "stdafx.h"
#include "Utility.h"

////////////////////////////////////////////////////////////////////////////////
//	t@C}bsONX
////////////////////////////////////////////////////////////
//==============================================================
//	RXgN^
//==============================================================
kitikuo::FILEMAP_DATA::FILEMAP_DATA() :
	dwSize(0L),
	hFile(NULL),
	hMap(NULL),
	lpMap(NULL)
{

}
//==============================================================
//	fXgN^
//==============================================================
kitikuo::FILEMAP_DATA::~FILEMAP_DATA()
{
	Release();
}
//==============================================================
//	wt@C}bv
//==============================================================
BOOL kitikuo::FILEMAP_DATA::Mapping(					//OUT	:
	LPCTSTR lpctPath,									//IN	:}bvt@CpX
	const int iMode										//IN	:[hi0=rA1=rwj
)
{
	ASSERT(lpctPath != NULL);
	Release();
	DWORD	dwFlags[4];
	switch (iMode) {
		case 0:		//	Read Only
			dwFlags[0] = GENERIC_READ;
			dwFlags[1] = FILE_SHARE_READ;
			dwFlags[2] = PAGE_READONLY;
			dwFlags[3] = FILE_MAP_READ;
			break;
		default:	//	Read / Write
			dwFlags[0] = GENERIC_READ | GENERIC_WRITE;
			dwFlags[1] = 0;
			dwFlags[2] = PAGE_READWRITE;
			dwFlags[3] = FILE_MAP_ALL_ACCESS;
			break;
	}
	hFile	= ::CreateFile(lpctPath, dwFlags[0], dwFlags[1], NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile != INVALID_HANDLE_VALUE) {
		dwSize	= ::GetFileSize(hFile, NULL);
		if (dwSize > 0) {
			hMap	= ::CreateFileMapping(hFile, NULL, dwFlags[2], 0, 0, NULL);
			if (hMap != NULL) {
				lpMap	= (LPBYTE)::MapViewOfFile(hMap, dwFlags[3], 0, 0, 0);
				if (lpMap != NULL) {
					return TRUE;
				}
			}
		}
	}
	Release();
	return FALSE;
}
//==============================================================
//	J
//==============================================================
void kitikuo::FILEMAP_DATA::Release()
{
	dwSize		= 0L;
	if (lpMap != NULL) {
		::UnmapViewOfFile(lpMap);
		lpMap	= NULL;
	}
	if (hMap != NULL) {
		::CloseHandle(hMap);
		hMap	= NULL;
	}
	if (hFile != NULL) {
		::CloseHandle(hFile);
		hFile	= NULL;
	}
}
